// ZAVAS(PC88) t@CJb^[

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "d88.h"

unsigned char buff[0x400*5*80];

D88 disk;
FILE *fp;

// wordlϐɑ
int getword(unsigned char *_p)
{
	int ret;
	ret = (_p[1]<<8) + _p[0];
	return ret;
}

// t@C̐؂o
bool fcut(char *_fname, int _trk, int _C, int _H, int _R, int _N, int _offset, int _size)
{
	if (!disk.ReadDATA(_trk, _C, _H, _R, _N, buff, _size+_offset)) return false;
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(buff + _offset, 1, _size, fp);
	fclose(fp);
	return true;
}

// ɓǂݍ񂾓ȅo
bool fsave(char *_fname, unsigned char *_p, int _size)
{
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(_p, 1, _size, fp);
	fclose(fp);
	return true;
}

// ȃf[^̐؂o
bool mcut(char *_fname, int _trk, int _C, int _H, int _R, int _offset, int _size)
{
	char fname[FILENAME_MAX];
	int fnp = 0;
	bool fck = true;
	if (!disk.ReadDATA(_trk, _C, _H, _R, 0x03, buff, _size)) return false;

	// ȃf[^̃`FbN
	int type = getword(&buff[_offset]);
	if (type != 0x0041 && type != 0x0042) return false;
	// t@C܂܂Ăꍇ͂̃t@Cgp
	if (buff[_offset+0x0006] != ' ') {
		for (int i=0; i<6; i++) {
			char c = buff[_offset+0x0006+i];
			if (c==' ') break;
			if (c<0x21 || c>0x7e) {
				fck = false;
				break;
			}
			fname[fnp++] = c;
		}
		fname[fnp++] = '\0';
	} else strcpy(fname, _fname);

	// ȃf[^̃t@CTCY̓f[^̒lgp
	int size = getword(&buff[_offset+0x0002]);
	printf ("cutting ... %s\n",_fname);
	fp = fopen(_fname,"wb");
	fwrite(&buff[_offset], 1, size, fp);
	fclose(fp);
	return true;
}

struct fpos
{
	bool musdata;
	int trk;
	int sec;
	int size;	// ̃TCY(ZN^TCY)
	int ofs;
	char* fname;
};

int main(int argc, char *argv[])
{
	char fname[FILENAME_MAX];
	int i,d;
	unsigned char id[]="GLODIA.DRIVE.(";

	// PROGRAM DISK
	struct fpos mp[] =
	{
		{ false, 0x01, 0x01, 0x5000, 0x0000, "PROG"   }, // CvO
		{ true,  0x2c, 0x05, 0x0400, 0x0000, "ZAGT01" }, // ȃf[^
		{ true,  0x2c, 0x05, 0x0400, 0x0200, "ZAGT02" }, //    V
		{ true,  0x2e, 0x03, 0x0400, 0x0000, "FAN1"   }, //    V
		{ true,  0x2e, 0x03, 0x0400, 0x0200, "FAN3"   }, //    V
		{ true,  0x35, 0x02, 0x1000, 0x0000, "ZABIG"  }, //    V
		{ true,  0x36, 0x01, 0x0c00, 0x0000, "ZAFIGH" }, //    V
		{ true,  0x36, 0x04, 0x0800, 0x0000, "ZAFIT2" }, //    V
		{ true,  0x37, 0x05, 0x0800, 0x0000, "ZASHOP" }, //    V
		{ true,  0x39, 0x01, 0x2400, 0x0000, "ZAOP02" }, //    V
		{ true,  0x3a, 0x05, 0x0400, 0x0000, "ZAOP01" }, //    V
		{ true,  0x3b, 0x01, 0x1800, 0x0000, "ZAED01" }, //    V
		{ true,  0x3c, 0x02, 0x0400, 0x0000, "ZACONG" }, //    V
		{ true,  0x3c, 0x03, 0x0400, 0x0000, "ZAMINA" }, //    V
		{ false, 0x00, 0x00, 0x0000, 0x0000, ""       }, // End of Data
	};

	// Disk A
	struct fpos ma[] =
	{
		{ true,  0x34, 0x01, 0x1400, 0x0000, "ZABG01" }, // ȃf[^
		{ true,  0x35, 0x01, 0x1400, 0x0000, "ZABG02" }, //    V
		{ true,  0x36, 0x01, 0x1400, 0x0000, "ZABG03" }, //    V
		{ true,  0x37, 0x01, 0x1400, 0x0000, "ZABG04" }, //    V
		{ true,  0x38, 0x01, 0x1400, 0x0000, "ZABG05" }, //    V
		{ true,  0x39, 0x01, 0x1400, 0x0000, "ZABG06" }, //    V
		{ false, 0x30, 0x01, 0x0400, 0x0000, "EXA000" }, // ʉ̃f[^
//		{ false, 0x30, 0x03, 0x0400, 0x0000, "EXA001" }, //    V
		{ false, 0x30, 0x03, 0x0400, 0x0000, "EXA002" }, //    V
		{ false, 0x30, 0x04, 0x0400, 0x0000, "EXA003" }, //    V
		{ false, 0x30, 0x05, 0x0400, 0x0000, "EXA004" }, //    V
		{ false, 0x31, 0x01, 0x0400, 0x0000, "EXA005" }, //    V
		{ false, 0x31, 0x02, 0x0400, 0x0000, "EXA006" }, //    V
		{ false, 0x31, 0x03, 0x0400, 0x0000, "EXA007" }, //    V
		{ false, 0x31, 0x04, 0x0400, 0x0000, "EXA008" }, //    V
		{ false, 0x31, 0x05, 0x0400, 0x0000, "EXA009" }, //    V
		{ false, 0x32, 0x01, 0x0400, 0x0000, "EXA010" }, //    V
		{ false, 0x32, 0x02, 0x0400, 0x0000, "EXA011" }, //    V
//		{ false, 0x32, 0x02, 0x0400, 0x0000, "EXA012" }, //    V
		{ false, 0x32, 0x04, 0x0400, 0x0000, "EXA013" }, //    V
//		{ false, 0x32, 0x04, 0x0400, 0x0000, "EXA014" }, //    V
		{ false, 0x33, 0x01, 0x0400, 0x0000, "EXA015" }, //    V
		{ false, 0x00, 0x00, 0x0000, 0x0000, ""       }, // End of Data
	};

	// Disk B
	struct fpos mb[] =
	{
		{ true,  0x34, 0x01, 0x1400, 0x0000, "ZABG07" }, // ȃf[^
		{ true,  0x35, 0x01, 0x1400, 0x0000, "ZABG08" }, //    V
		{ true,  0x36, 0x01, 0x1400, 0x0000, "ZABG09" }, //    V
		{ true,  0x37, 0x01, 0x1400, 0x0000, "ZABG10" }, //    V
		{ true,  0x38, 0x01, 0x1400, 0x0000, "ZABG11" }, //    V
		{ true,  0x39, 0x01, 0x1400, 0x0000, "ZAOPBG" }, //    V
		{ false, 0x30, 0x01, 0x0400, 0x0000, "EXB000" }, // ʉ̃f[^
//		{ false, 0x30, 0x02, 0x0400, 0x0000, "EXB001" }, //    V
//		{ false, 0x30, 0x03, 0x0400, 0x0000, "EXB002" }, //    V
		{ false, 0x30, 0x04, 0x0400, 0x0000, "EXB003" }, //    V
		{ false, 0x30, 0x05, 0x0400, 0x0000, "EXB004" }, //    V
//		{ false, 0x31, 0x01, 0x0400, 0x0000, "EXB005" }, //    V
		{ false, 0x31, 0x02, 0x0400, 0x0000, "EXB006" }, //    V
		{ false, 0x31, 0x03, 0x0400, 0x0000, "EXB007" }, //    V
		{ false, 0x31, 0x04, 0x0400, 0x0000, "EXB008" }, //    V
//		{ false, 0x31, 0x05, 0x0400, 0x0000, "EXB009" }, //    V
		{ false, 0x32, 0x01, 0x0400, 0x0000, "EXB010" }, //    V
		{ false, 0x32, 0x02, 0x0400, 0x0000, "EXB011" }, //    V
//		{ false, 0x32, 0x03, 0x0400, 0x0000, "EXB012" }, //    V
		{ false, 0x32, 0x04, 0x0400, 0x0000, "EXB013" }, //    V
//		{ false, 0x32, 0x05, 0x0400, 0x0000, "EXB014" }, //    V
		{ false, 0x33, 0x01, 0x0400, 0x0000, "EXB015" }, //    V
		{ false, 0x00, 0x00, 0x0000, 0x0000, ""       }, // End of Data
	};

	if (argc != 2)
	{
		// IvVw肪ȂƂ
		fprintf(stderr, "Usage: %s [d88file]\n",argv[0]);
		return 1;
	}

	if (!disk.SetFile(argv[1]))
	{
		fprintf(stderr, "t@CI[vł܂.\n");
		return 1;
	}

	int numdisk = disk.GetNumDisk();
	for (d=0; d<numdisk; d++)
	{
		disk.SelectDisk(d);
		disk.SetRecordRange(0x01,0x05);
		// fBXN
		disk.ReadDATA(0x4f, 0x27, 0x01, 0x05, 0x03, buff, 0x400);
		if (!memcmp(&buff[0x03f0], id, sizeof(id)-1)) {
			switch (buff[0x03fe]) {
			case '0':
				printf("PROGRAM DISKF܂.\n");
				for (i=0; mp[i].size; i++) {
					if (mp[i].musdata) {
						mcut(mp[i].fname, mp[i].trk, mp[i].trk>>1, mp[i].trk&1, mp[i].sec, mp[i].ofs, mp[i].size);
					} else {
						fcut(mp[i].fname, mp[i].trk, mp[i].trk>>1, mp[i].trk&1, mp[i].sec, 0x03, mp[i].ofs, mp[i].size);
					}
				}
				break;

			case '1':
				printf("DISK AF܂.\n");
				for (i=0; ma[i].size; i++) {
					if (ma[i].musdata) {
						mcut(ma[i].fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, ma[i].ofs, ma[i].size);
					} else {
						fcut(ma[i].fname, ma[i].trk, ma[i].trk>>1, ma[i].trk&1, ma[i].sec, 0x03, ma[i].ofs, ma[i].size);
					}
				}
#if 0
				// ǉf[^̐؂o
				disk.ReadDATA(0x30, 0x18, 0x00, 0x01, 0x03, buff, 0x400*16);
				for (i=0; i<16; i++) {
					sprintf(fname,"EXA%03d",i);
					fsave(fname, &buff[i*0x400], 0x0400);
				}
#endif
				break;

			case '2':
				printf("DISK BF܂.\n");
				for (i=0; mb[i].size; i++) {
					if (mb[i].musdata) {
						mcut(mb[i].fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, mb[i].ofs, mb[i].size);
					} else {
						fcut(mb[i].fname, mb[i].trk, mb[i].trk>>1, mb[i].trk&1, mb[i].sec, 0x03, mb[i].ofs, mb[i].size);
					}
				}
#if 0
				// ǉf[^̐؂o
				disk.ReadDATA(0x30, 0x18, 0x00, 0x01, 0x03, buff, 0x400*16);
				for (i=0; i<16; i++) {
					sprintf(fname,"EXB%03d",i);
					fsave(fname, &buff[i*0x400], 0x0400);
				}
				break;
#endif
			default:
				break;
			}
		}
	}
	return 0;
}

